"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createContext = void 0;
var React = require("react");
var symbolObservable_1 = require("./utils/symbolObservable");
var Context_1 = require("./components/Context");
function createUnimplemented(objectName) {
    var prefix = objectName ? objectName + "." : "";
    return function createUnimplemented(methodName) {
        return function unimplemented() {
            throw new Error("Unimplemented method: " + prefix + methodName);
        };
    };
}
function createContext(rootReducer, preloadedState, enhancer, displayName, global) {
    var _a;
    if (global === void 0) { global = false; }
    var unimplemented = createUnimplemented("Context(" + (displayName !== null && displayName !== void 0 ? displayName : "") + ")");
    var Context = React.createContext((_a = {
            dispatch: function (a) { return a; },
            enhancer: enhancer,
            getState: function () { return preloadedState; },
            reducer: rootReducer,
            state: preloadedState
        },
        _a[symbolObservable_1.SymbolObservable] = unimplemented(symbolObservable_1.SymbolObservable.toString()),
        _a));
    if (displayName) {
        Context.displayName = displayName;
    }
    if (global) {
        Context_1.setGlobalContext(Context);
    }
    return Context;
}
exports.createContext = createContext;
